
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>在U-boot中添加以太网驱动 / iVAN</title>

    <meta name="description" content="在U-boot中添加以太网驱动 当定义CONFIG_CMD_NET和CONFIG_CMD_PING,编译之后执行ping命令,告警没有找到以太网. 因此,需要打开U-boot的网络功能, u-boot-sunxi-sunxi中没有找到明显的网络驱动代码,或许有通用的驱动,但可以获得资料的途径有限,再说我是个初学者,平时工作属于自动控制类,网络方面很菜,因此想通过修改一个网络驱动,进行一次初步学习,想到就开工... 边做边写,恐怕会比较乱.   开发环境:   1.笔记本RHEL5,安装编译器arm-none-eabi-版本4.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">在U-boot中添加以太网驱动</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>当定义CONFIG_CMD_NET和CONFIG_CMD_PING，编译之后执行ping命令，告警没有找到以太网。</p>
<p>因此，需要打开U-boot的网络功能， u-boot-sunxi-sunxi中没有找到明显的网络驱动代码，或许有通用的驱动，但可以获得资料的途径有限，再说我是个初学者，平时工作属于自动控制类，网络方面很菜，因此想通过修改一个网络驱动，进行一次初步学习，想到就开工...</p>
<p>边做边写，恐怕会比较乱。</p>
<p> </p>
<p>开发环境：   1、笔记本RHEL5，安装编译器arm-none-eabi-版本4.7.2； 编辑器Vim；minicom2.1</p>
<p>                     2、台式机XPsp3，安装SourceInsight3.5</p>
<p>基本思路：  1、找到u-boot内网络代码运行的轨迹，初始化、数据交换的驱动接口等等</p>
<p>                     2、实现一个驱动，加入到这个运行轨迹中，设备初始化，数据读写等等</p>
<p>准备工作：   1、找到芯片资料，这个比较坑，只能找到RTL8021CP的PDF，至于CPU芯片资料，</p>
<p>                            ×，那简直不能称为资料，看看三星处理器资料，为啥别人能做大，不是没有原因的。</p>
<p>                     2、Cubieboard原理图一份，这个好弄，人手一份呀</p>
<p>                     3、网线准备了两根，一个常用上网的，一根交叉线。路由器一只。</p>
<p>                            在没有研究清楚硬件连接之前，这样准备应该比较充足了。</p>
<p>                     4、下个新版本编译器，找了一个arm-none-eabi-的编译器，版本4.7.2，估计是目前最高版本。</p>
<p>                            下载：<a href="http://www.codesourcery.com/sgpp/lite/arm" rel="external nofollow noreferrer">http:<strong>//</strong>www.codesourcery.com<strong>/</strong>sgpp<strong>/</strong>lite<strong>/</strong>arm</a></p>
<p>                            选择arm处理器，linux版本，点进去之后需要用邮箱注册，下载地址会发到邮箱。</p>
<p>                     5、因为没有CPU资料，需要寻找一个A10的网络驱动代码，在支持Cubieboard的内核中找到了。</p>
<p>                           下载：<a href="http://linux-sunxi.org/Cubieboard/Cubieboard_Linux-3.9" rel="external nofollow noreferrer">http://linux-sunxi.org/Cubieboard/Cubieboard_Linux-3.9</a></p>
<p>                            这个驱动是linux下的，需要修改一下或参考其操作硬件的过程，以便在u-boot内运行。</p>
<p> </p>
<p><strong>一、环境建立，初步编译</strong></p>
<p>        考虑到这次需要参考其他开发板或CPU的网络驱动，因此用SourceInsight3.5建立一个u-boot-sunxi-sunxi的工程，建立关联关系，方便代码查阅。建立方法很简单，不懂的可以网上搜索一下。建立工程时不要删除其他代码，全部使用。</p>
<p>        linux下编译环境设置，将下载的编译器解压到 /usr/local/arm/目录，解压之后目录是arm-2012.09</p>
<p>        设置环境变量，在RHEL5系统内，在/ect/profile的末尾加上一句：</p>
<p>        export   PATH=$PATH:/usr/local/arm/arm-2012.09/bin</p>
<p>        保存之后，执行：source /ect/profile 或者logout，或者重启机器。</p>
<p>        回到bash，输入arm再按Tab键，可以看到编译工具链列出来了，执行</p>
<p>        arm-none-eabi-gcc   -v，可以看到版本是4.7.2</p>
<p>        其他系统编译器安装设置可以在网上搜索，有很多文章会提到。</p>
<p>        进入u-boot-sunxi-sunxi目录，修改Makefile内容，找到 CROSS_COMPILE ?=  这一行</p>
<p>        改为：CROSS_COMPILE ?= arm-none-eabi-</p>
<p>        进入 u-boot-sunxi-sunxi/arch/arm，修改config.mk内容，也是这一句 CROSS_COMPILE ?= </p>
<p>        改为：CROSS_COMPILE ?= arm-none-eabi-</p>
<p> </p>
<p>       回到u-boot-sunxi-sunxi目录，执行：</p>
<p>       make  distclean                     //清除之前编译的内容</p>
<p>       make  cubieboard_config     //设置板子</p>
<p>       make  -j4                                //编译，-j4表示多线程编译，可以使用-j2，如果是虚拟机可以不用这个参数，</p>
<p>                                                       //如果电脑配置比较好，可以使用 -j8</p>
<p> </p>
<p>      等待一会，不出意外，编译完成，写入SD卡，到板子上运行，可以看到串口输出信息。</p>
<p> </p>
<p><strong>二、U-boot网络模块分析</strong></p>
<p>      <strong>1、网络初始化</strong></p>
<p>       之前曾经分析过主循环，在主循环main_loop()调用之前就是初始化。</p>
<p>       在文件\u-boot-sunxi-sunxi\arch\arm\lib\board.c， 函数board_init_r()内：</p>
<p>       ...........</p>
<p>        #if defined(CONFIG_CMD_NET)<br />
        puts("Net:   ");<br />
        eth_initialize(gd-&gt;bd);<br />        #if defined(CONFIG_RESET_PHY_R)<br />
        debug("Reset Ethernet PHY\n");<br />
        reset_phy(); <br />
        #endif<br />
        #endif</p>
<p>        ...........</p>
<p>       这一段代码可以看出，要执行网络初始化，需要定义CONFIG_CMD_NET。</p>
<p>       因此在\u-boot-sunxi-sunxi\include\configs\sunxi-common.h 末尾加一句：</p>
<p>       #define  CONFIG_CMD_NET</p>
<p> </p>
<p>      再来看看函数eth_initialize() 的内容，在文件 \u-boot-sunxi-sunxi\net\eth.c内：</p>
<p>       .................</p>
<p>       if (board_eth_init != __def_eth_init) {<br />
             if (board_eth_init(bis) &lt; 0)<br />
             printf("Board Net Initialization Failed\n");<br />
       } else if (cpu_eth_init != __def_eth_init) {<br />
             if (cpu_eth_init(bis) &lt; 0)<br />
                    printf("CPU Net Initialization Failed\n");<br />
       } else<br />
             printf("Net Initialization Skipped\n");</p>
<p>       .................</p>
<p>       如果只定义CONFIG_CMD_NET，在上电时就会打印 Net Initialization Skipped，执行了最后一个else的内容，因此，需要完成网络初始化，需要实现函数board_eth_init()或者cpu_eth_init()</p>
<p>       看代码，这两个函数谁等于__def_eth_init就执行谁，在看看__def_eth_init是啥，也在eth.c这个文件内</p>
<p>       static int   __def_eth_init(bd_t *bis)<br />
       {<br />
              return -1;<br />
       }<br />
       int cpu_eth_init(bd_t *bis) __attribute__((weak, alias("__def_eth_init")));<br />
       int board_eth_init(bd_t *bis) __attribute__((weak, alias("__def_eth_init")));</p>
<p>       可见，实现__def_eth_init的“alias  ”，bash命令里面有个alias，如果你用过就明白这是什么意思了，实现它，就可以进行初始化啦。</p>
<p>       想知道weak, alias是什么意思，请围观这位大侠的博客 <a href="http://blog.chinaunix.net/uid-20272712-id-1969771.html" rel="external nofollow noreferrer">http://blog.chinaunix.net/uid-20272712-id-1969771.html</a></p>
<p>       以太网模块在A10内，A10的手册称之为WEMAC模块，因此，我们需要实现cpu_eth_init函数，表明eathnet模块在CPU内部。</p>
<p>       在文件\u-boot-sunxi-sunxi\arch\arm\cpu\armv7\sunxi\board.c内增加函数cpu_eth_init，内容如下：</p>
<p>   </p>
<p>      #ifdef   CONFIG_SUN4I_WEMAC</p>
<p>       int cpu_eth_init(bd_t *bis)<br />
       {<br />
              return   sun4i_wemac_initialize(bis);<br />
       }<br />
       #endif</p>
<p>     <strong> 2、如何实现网络模块</strong></p>
<p>      网络模块已经成熟了，我们并不需要增加很多代码，只需要实现对硬件的操作就可以了。</p>
<p>      基本的操作大约就几个：初始化、打开、关闭、接收、发送、挂起</p>
<p>      分析\u-boot-sunxi-sunxi\net目录内的代码，发现网络的数据结构定义在\u-boot-sunxi-sunxi\include\net.h内</p>
<p>      struct eth_device {<br />
           char name[16];                                                                              //网络名<br />
           unsigned char enetaddr[6];                                                         //以太网地址<br />
           int iobase;                                                                                       //io基址？<br />
           int state;                                                                                          //设备状态</p>
<p>          </p>
<p>           int  (*init) (struct eth_device *, bd_t *);                                       //网络设备初始化<br />
           int  (*send) (struct eth_device *, void *packet, int length);     //发送数据<br />
           int  (*recv) (struct eth_device *);                                                  //接收数据<br />
           void (*halt) (struct eth_device *);                                                 //挂起<br />
           #ifdef CONFIG_MCAST_TFTP<br />
           int (*mcast) (struct eth_device *, u32 ip, u8 set);<br />
           #endif<br />
           int  (*write_hwaddr) (struct eth_device *);                                 //写硬件地址？这个是啥？<br />
           struct eth_device *next;<br />
           int index;<br />
           void *priv;<br />
      };</p>
<p>       struct eth_device结构体定义了网络设备的基本操作，从面向对象的角度来说，只要在驱动代码内将struct eth_device的init，send，recv，halt，write_hwaddr这几种方法实现，就可以实现网络的操作了，至于数据收回来之后在上层的解析方式那就不是驱动关心的了。任务变得简单了，实现这几种操作便可</p>
<p>      再看struct eth_device结构体下面这几个函数：</p>
<p>      extern int eth_initialize(bd_t *bis); /* Initialize network subsystem */<br />
      extern int eth_register(struct eth_device* dev);/* Register network device */<br />
      extern int eth_unregister(struct eth_device *dev);/* Remove network device */<br />
      extern void eth_try_another(int first_restart); /* Change the device */<br />
      extern void eth_set_current(void);  /* set nterface to ethcur var */</p>
<p>      都在\u-boot-sunxi-sunxi\net\eth.c内实现，分析一下eth_register这个函数(其他的就不多说了)，如下，</p>
<p>      int  eth_register( struct eth_device  *dev )<br />
      {<br />
             struct eth_device *d;<br />
             static int index;</p>
<p>             assert( strlen(dev-&gt;name)  &lt;  sizeof(dev-&gt;name) );</p>
<p>             if (!eth_devices) {  </p>
<p>             //注册之前eth_devices应该初始化为NULL，在当前文件的函数int  eth_initialize( bd_t *bis ) 中，</p>
<p>             //开始几句代码就这样初始化了，但是这个函数eth_initialize将调用我们自己写的cpu_eth_init()，</p>
<p>             //并未调用eth_register，因此可以预见，自己写的函数cpu_eth_init将要调用eth_register对网络进行注册，</p>
<p>             //实际工作还是要自己实现<br />
                   eth_current = eth_devices = dev;<br />
                   eth_current_changed();<br />
              } else {<br />
                   for (d = eth_devices; d-&gt;next != eth_devices; d = d-&gt;next)<br />
                         ;<br />
                   d-&gt;next = dev;<br />
              }</p>
<p>              dev-&gt;state  =  ETH_STATE_INIT;     //网络设备状态为初始化<br />
              dev-&gt;next    =  eth_devices;               //链表的下一个指向自己，为啥呢？<br />
              dev-&gt;index  =  index++;                       //设备个数增加了</p>
<p>              return 0;<br />
       }</p>
<p> </p>
<p><strong>三、实现网络驱动</strong></p>
<p>      这些内容都将实现在sun4i_wemac.c和sun4i_wemac.h内。这两个文件都在\u-boot-sunxi-sunxi\driver\net\目录下。      </p>
<p>     <strong>1、数据结构</strong></p>
<p>      经过上面分析，可以了解到，假设自己定义一个网络设备的数据结构，那么这个结构大致如下，下面直接写一个，实际代码还要推敲推敲：</p>
<p>      struct   sun4i_wemac_dev {<br />
 </p>
<p>             void   *wemac_base;    // A10内部wemac模块的基地址</p>
<p>             void   *gpio_base;          //wemac模块使用的gpio的基地址，去看看原理图，实际使用A10的PA口</p>
<p>           </p>
<p>             //接收发送buffer管理，使用队列</p>
<p>             unsigned int  rx_head;<br />
             unsigned int  rx_tail;<br />
             unsigned int  tx_head;<br />
             unsigned int  tx_tail;</p>
<p>             void   *rx_buffer;<br />
             void   *tx_buffer;</p>
<p>             struct   eth_device   netdev;      //这就是上面的以太网设备，这个一定要有<br />
             unsigned short     phy_addr;    //PHY地址，就是板子上RTL8201CP的地址<br />
       };</p>
<p>       有的人又问啦，为什么要自己定义一个数据结构呢？net.h里面不是已经有一个struct eth_device了吗？仔细想一下，struct eth_device是u-boot定义的数据结构，里面的每一个成员可能在u-boot的其他网络模块代码中被使用修改，我们并不完全知道所有代码对struct eth_device的操作，因此需要自己定义一个结构，提供这个接口就可以了。用一句话总结就是：struct eth_device是定义给u-boot的网络模块使用的，用户得定义自己的设备，以此隔离了驱动代码与u-boot代码。</p>
<p>      <strong> 2、实现初始化</strong></p>
<p>       就是上面提到的cpu_eth_init()内调用的sun4i_wemac_initialize()函数，只写一个思路，具体代码还需要推敲： </p>
<p>       int   sun4i_wemac_initialize(  bd_t  *bis  )</p>
<p>       {</p>
<p>            struct   sun4i_wemac_dev  *wemac_dev;    //自己定义的结构</p>
<p>            struct   eth_device   *netdev;                            //u-boot已经定义的结构</p>
<p>           wemac_dev  =  malloc( sizeof ( struct sun4i_wemac_dev  ) );   //分配内存<br />
           if ( wemac_dev  ) {<br />
                  printf("Error: Failed to allocate memory for WEMAC\n");<br />
                  return -1;<br />
           }<br />
           memset(wemac_dev , 0, sizeof( struct    sun4i_wemac_dev  ));            </p>
<p>           netdev = &amp;wemac_dev -&gt;netdev;</p>
<p>          /*****************************/</p>
<p>          初始化发送、接收管理队列</p>
<p>          若还需要其他功能，可以增加到数据结构struct   sun4i_wemac_dev中，并在此初始化，</p>
<p>         写文章时，代码还没写，留待后续补全</p>
<p>          /*****************************/</p>
<p>          wemac_dev -&gt;wemac_base =  (void *)EMAC_BASE;</p>
<p>          wemac_dev -&gt;gpio_base      =  (void *)PA_BASE;</p>
<p>          wemac_dev -&gt;phy_addr        = WEMAC_PHY;</p>
<p>          </p>
<p>          //以下就是要实现的网络设备结构体内的“方法”，就是驱动代码中主要的几个函数，</p>
<p>          //可以参考从内核拷贝过来的驱动是如何实现的：</p>
<p>           netdev-&gt;init                      = sun4i_wemac_init;      //注意这个初始化函数跟当前函数是不同的，这个函数</p>
<p>                                                                                                  //主要初始化wemac模块和RTL8201芯片<br />
           netdev-&gt;halt                     = sun4i_wemac_halt;<br />
           netdev-&gt;send                  = sun4i_wemac_send;<br />
           netdev-&gt;recv                    = sun4i_wemac_recv;<br />
           netdev-&gt;write_hwaddr   = sun4i_wemac_write_hwaddr;</p>
<p>           .....................其他初始化...........</p>
<p>           eth_register( netdev );    // 最后将网络设备注册，这样u-boot就能使用驱动程序啦</p>
<p>                                                       // 注册之后，eth.c内的全局变量eth_current 指向wemac_dev -&gt;netdev，</p>
<p>                                                       //这是在u-boot任何代码使用eth_current，</p>
<p>                                                       // 都表示使用的是现在初始化的模块</p>
<p>            return 0;</p>
<p>       }<br />
      </p>
<p>       <strong>3、其他模块的实现</strong></p>
<p>       看看eth.c内怎么实现接收和发送接口的，就可以知道驱动代码应该怎么写了</p>
<p>       int eth_send(void *packet, int length)<br />
       {<br />
             if ( !eth_current )                         //eth_current是全局指针，指向驱动初始化的结构体wemac_dev -&gt;netdev<br />
                  return -1;</p>
<p>            return eth_current-&gt;send(eth_current, packet, length);  //注册之后，实际调用就是sun4i_wemac_send；<br />
       }</p>
<p>       int eth_rx(void)<br />
       {<br />
            if (!eth_current)<br />
                   return -1;</p>
<p>             return eth_current-&gt;recv(eth_current);  //注册之后，实际调用就是sun4i_wemac_recv；</p>
<p>       }</p>
<p>       因此，可以知道，驱动代码实现的接收发送形式如下：</p>
<p>      static  int   sun4i_wemac_send( struct  eth_device  *dev,  void  *packet,   int  length )</p>
<p>      {</p>
<p>             struct   sun4i_wemac_dev  wemac_dev  = <br />
to_wemac(dev);            </p>
<p>             //功能如何实现，可以参考内核代码的驱动。</p>
<p>      } </p>
<p>     <br />
      static  int   sun4i_wemac_recv( struct  eth_device   *dev )</p>
<p>      {</p>
<p>              struct   sun4i_wemac_dev  wemac_dev  =  to_wemac(dev); </p>
<p>              //功能如何实现，可以参考内核代码的驱动。</p>
<p>      }</p>
<p>      由于我们自己定义的结构体是struct   sun4i_wemac_dev，而传过来的参数是全局指针eth_current，</p>
<p>      根据上面的分析，eth_current指向struct   sun4i_wemac_dev结构内的struct   eth_device   netdev，</p>
<p>      因此要获得指向struct   sun4i_wemac_dev的指针需要使用linux内核常用的手段，“容器”的概念就出来了，</p>
<p>      看代码定义： </p>
<p>      struct   sun4i_wemac_dev  wemac_dev  =  container_of(  dev ,  struct   sun4i_wemac_dev ,  netdev);</p>
<p>      就可以获得注册之前申请的结构体的首地址，如何办到的呢？</p>
<p>      来看看这个在linux内核中常用的宏：</p>
<p>      #define   container_of( ptr, type, member )       ( {   \<br />
                                                                                           const typeof( ((type *)0)-&gt;member ) *__mptr  =  (ptr); \<br />
                                                                                           (type *)( (char *)__mptr - offsetof(type,member) ); }  )</p>
<p>     #define   offsetof( TYPE, MEMBER )     ( (size_t)  &amp; ((TYPE *)0)-&gt;MEMBER )</p>
<p> </p>
<p>      这是一个很神奇的宏，可以把它用于自己以后的C代码开发中，如果使用其他编译器，这里面的关键字要改一下。</p>
<p>      意思就是，dev指向的内存地址，减掉它在struct   sun4i_wemac_dev中的偏移量，就获得了初始化时定义的</p>
<p>struct   sun4i_wemac_dev 指针</p>
<p>      偏移量的获取很简单 (( struct   sun4i_wemac_dev *) 0)-&gt;netdev  就是偏移量；我们知道使用 -&gt; 操作时，获得指向当前结构体的某一个成员的地址， 而这个成员的地址与结构体首地址的差值，就是它在结构体内的偏移量，如果把结构体的首地址设置为0，结果妙不可言。</p>
<p>      由于很多函数都要用到这个宏，因此可以再写成下面这样：</p>
<p>      #define  to_wemac(_nd)    container_of( _nd,  struct   sun4i_wemac_dev, netdev)</p>
<p>      上面的定义就可以这样:  struct   sun4i_wemac_dev  wemac_dev  =  to_wemac(dev);    </p>
<p>      </p>
<p>       另外3个个函数，实现方式也是一样，先去分析eth.c内调用，一并都分析一下吧：</p>
<p>       int eth_init(bd_t *bis)<br />
       {<br />
              struct eth_device *old_current, *dev;</p>
<p>              if (!eth_current) {                   //必须注册成功之后，否则这里判断失败，将打印找不到ethernet<br />
                      puts("No ethernet found.\n");<br />
                      return -1;<br />
              }</p>
<p>             /* Sync environment with network devices */<br />
             dev = eth_devices;<br />
             do {<br />
                    uchar env_enetaddr[6];</p>
<p>                    if ( eth_getenv_enetaddr_by_index( "eth",   dev-&gt;index,  env_enetaddr))                               </p>
<p>                             memcpy(dev-&gt;enetaddr, env_enetaddr, 6);  </p>
<p>                             //这里就是获取IP地址了，从哪里获取呢？这是u-boot解决的问题啦                                        </p>
<p>                             //熟悉情况的人这时会想起一个文件，就是u-boot移植时说的参数配置文件</p>
<p>                             //uEnv.txt或boot.scr，怎么获得，需要进一步追查代码流程，这不是网络驱动关心的。</p>
<p>                    dev = dev-&gt;next;<br />
             } while ( dev  !=  eth_devices );          // CB上只有一个以太网设备，因此循环一次就会结束</p>
<p>            old_current = eth_current;<br />
            do {<br />
                       debug("Trying %s\n", eth_current-&gt;name);</p>
<p>                       if ( eth_current-&gt;init( eth_current, bis )  &gt;=  0 ) { //实际调用的就是函数sun4i_wemac_init ，</p>
<p>                                                                                                            //对WEMAC模块和PHY芯片进行初始化<br />
                              eth_current-&gt;state = ETH_STATE_ACTIVE;    //初始化成功，处于活动状态标志</p>
<p>                              return 0;    //成功就返回啦<br />
                      }<br />
                      debug("FAIL\n");</p>
<p>                      eth_try_another(0);  //不成功，试试另一个，不用分析，这个函数可定会尝试改变全局指针eth_current<br />
             } while (old_current != eth_current);</p>
<p>             return -1;<br />
      }</p>
<p>      还有一个疑问，那又是什么地方调用int eth_init(bd_t *bis)这个函数呢？借助强大的Source Insight，很快就能找到调用它的地方啦，搜索工程，出来一大片，只需关心文件net.c的调用即可，其他调用是不会被编译进来的，以下两个函数调用了这个初始化，从名字就能看出其大概功能了</p>
<p>      int  NetLoop( enum   proto_t protocol )；  //这就是读取网络数据的主循环</p>
<p>      void  NetStartAgain( void )；                        //这个是net重新开始，当然要初始化</p>
<p>      再来看看ping命令干了啥，在文件\u-boot-sunxi-sunxi\common\cmd_net.c</p>
<p>      #if defined(CONFIG_CMD_PING)<br />
      int do_ping (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])<br />
      {<br />
            if (argc &lt; 2)<br />
                 return -1;</p>
<p>            NetPingIP = string_to_ip(argv[1]);<br />
            if (NetPingIP == 0)<br />
                   return CMD_RET_USAGE;</p>
<p>            if (NetLoop(PING) &lt; 0) {    //这里调用了NetLoop函数，再调用eth_init，再调用自己写的sun4i_wemac_init <br />
                   printf("ping failed; host %s is not alive\n", argv[1]);<br />
                   return 1;<br />
            }</p>
<p>            printf("host %s is alive\n", argv[1]);</p>
<p>            return 0;<br />
        }</p>
<p>        U_BOOT_CMD(<br />
                                     ping, 2, 1, do_ping,<br />
                                    "send ICMP ECHO_REQUEST to network host",<br />
                                    "pingAddress"<br />
        );<br />
        #endif</p>
<p>        至于NetLoop内如何实现数据打包，如何解析，有兴趣的可以继续深入。</p>
<p> </p>
<p>      void eth_halt(void)<br />
      {<br />
              if (!eth_current)<br />
              return;</p>
<p>              eth_current-&gt;halt(eth_current); <br />
//实际就是调用sun4i_wemac_halt，网络设备挂起</p>
<p>              eth_current-&gt;state = ETH_STATE_PASSIVE; //标志变化<br />
      }</p>
<p>     int eth_write_hwaddr(struct eth_device *dev, const char *base_name,  int eth_number)<br />
     {<br />
              unsigned char env_enetaddr[6];<br />
              int ret = 0;</p>
<p>              eth_getenv_enetaddr_by_index(base_name, eth_number, env_enetaddr);</p>
<p>              if (memcmp(env_enetaddr, "\0\0\0\0\0\0", 6)) {<br />
                      if (memcmp(dev-&gt;enetaddr, "\0\0\0\0\0\0", 6) &amp;&amp;  memcmp(dev-&gt;enetaddr, env_enetaddr, 6)) {<br />
                                printf("\nWarning: %s MAC addresses don't match:\n", dev-&gt;name);<br />
                                printf("Address in SROM is         %pM\n", dev-&gt;enetaddr);<br />
                                printf("Address in environment is  %pM\n", env_enetaddr);<br />
                      }</p>
<p>                      memcpy(dev-&gt;enetaddr, env_enetaddr, 6);<br />
              } else if (is_valid_ether_addr(dev-&gt;enetaddr)) {<br />
                      eth_setenv_enetaddr_by_index(base_name, eth_number,  dev-&gt;enetaddr);<br />
                       printf("\nWarning: %s using MAC address from net device\n", dev-&gt;name);<br />
              }</p>
<p>              if (dev-&gt;write_hwaddr &amp;&amp;  !eth_mac_skip(eth_number)) {<br />
                      if (!is_valid_ether_addr(dev-&gt;enetaddr))<br />
                               return -1;</p>
<p>                     ret = dev-&gt;write_hwaddr(dev);//实际就是调用sun4i_wemac_write_hwaddr，将IP地址写入硬件??<br />
              }</p>
<p>             return ret;<br />
      }</p>
<p> </p>
<p>      这三个函数形式如下：</p>
<p>      int     sun4i_wemac_init ( struct eth_device *, bd_t * );<br />
      void  sun4i_wemac_halt( struct eth_device * );<br />
      int     sun4i_wemac_write_hwaddr( struct eth_device * );             </p>
<p>      具体内容如何实现，在没有详细CPU手册的情况下，参考内核驱动代码是最好的选择，如果熟悉内核驱动编程就更好了，那是下一个目标。</p>
<p> </p>
<p><strong>四、驱动完成之后的初步测试</strong></p>
<p>      测试ping命令</p>
<p>      测试tftp命令-----这个命令还没有，下一次学习的目标。</p>
<p>      代码还没写，留待后续补全</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 18:58:00</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>在U-boot中添加以太网驱动的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My396Ez.html" rel="bookmark">使用Spring Boot日志框架在已有的微服务代码中添加日志功能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言:我们需要在已有的微服务代码中添加日志功能,用于输出需要关注的内容,这是最平常的技术需求了.由于我们的微服务代码是基于SpringBoot开发的,那么问题就转换为如何在Spring Boot应用程序中输出相应的日志. 在传统Java应用程序中,我们一般会使用类似Log4j这样的日志框架来输出日志,而不是直接在代码中通过System.out.println()来输出日志.为什么要这么做呢?原因有两点.其一,我们希望日志能输出到文件中,而不是输出到应用程序的控制台中,这样更加容易收集和分析.其二			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPWBelM.html" rel="bookmark">全志平台boot框架中增加设备驱动过程分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				全志平台boot框架中增加设备驱动过程分析          在boot启动阶段,大家都知道他的主要目的就是引导uboot,uboot在引导内核,从而让整个系统运作起来.全志的boot阶段,对应平板这一块,它会驱动LCD,显示一些开机LOGO,这个过程很快,也就1-2秒钟的时间.然而对于车载行业应用来说,可能需要再boot阶段做一些事情.比如,机器冷启动,大家都知道android启动时间还是比较长的,那么怎么使得客户能快速的用上倒车影像的功能呢?这就需要动脑筋了. /**************			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8PGYb.html" rel="bookmark">springboot&lpar;十一&rpar;：Spring boot中mongodb的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				mongodb是最早热门非关系数据库的之一,使用也比较普遍,一般会用做离线数据分析来使用,放到内网的居多.由于很多公司使用了云服务,服务器默认都开放了外网地址,导致前一阵子大批 MongoDB 因配置漏洞被攻击,数据被删,引起了人们的注意,感兴趣的可以看看这篇文章:场屠戮MongoDB的盛宴反思:超33000个数据库遭遇入侵勒索,同时也说明了很多公司生产中大量使用mongodb. mongodb简介 MongoDB(来自于英文单词&quot;Humongous&quot;,中文含义为&quot;庞大&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwV4jp.html" rel="bookmark">Spring Boot中集成Spring Security  专题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				if语句中条件判断就是检查当前的url请求是否是logout-url的配置值,接下来,获取用户的authentication,并循环调用处理器链中各个处理器的logout()函数,前面在parse阶段说过,处理器链中有两个实例,处理会话的SecurityContextLogoutHandler及remember-me服务,我们来一一看看它们的logout函数实现: 2.1.0 SecurityContextLogoutHandler public void logout(HttpServletR			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1PBdz.html" rel="bookmark">Linux内核中SPI总线驱动分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文主要有两个大的模块:一个是SPI总线驱动的分析 (研究了具体实现的过程): 另一个是SPI总线驱动的编写(不用研究具体的实现过程).  1 SPI概述       SPI是英语Serial Peripheral interface的缩写,顾名思义就是串行外围设备接口,是Motorola首先在其MC68HCXX系列处理器上定义的.SPI接口主要应用在 EEPROM,FLASH,实时时钟,AD转换器,还有数字信号处理器和数字信号解码器之间.SPI是一种高速的,全双工,同步的通信总线,并且在芯片的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4e4Ajb.html" rel="bookmark">FL2440的U-boot-2009&period;08移植（五）uboot架构中NAND Flash驱动修改</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				移植NAND花了我一下午的时间才把他弄明白,解决错误的途中,我也学到了更多的东西,希望大家自己要尝试亲手移植,不要老是用别人的补丁文件,自己你懂手做了才真正是你的东西.       分析了一下Uboot中Nandflash的驱动,u-boot-2009.08使用的是和Linux内核一样的MTD(内存技术设备)架构.在Uboot下对Nand的支持体现在命令行下实现对nand flash的操作,为:nand info,nand device,nand read,nand write,nand ere			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX0xaLp.html" rel="bookmark">springboot&lpar;三&rpar;：Spring boot中Redis的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				spring boot对常用的数据库支持外,对nosql 数据库也进行了封装自动化. redis介绍 Redis是目前业界使用最广泛的内存数据存储.相比memcached,Redis支持更丰富的数据结构,例如hashes, lists, sets等,同时支持数据持久化.除此之外,Redis还提供一些类数据库的特性,比如事务,HA,主从库.可以说Redis兼具了缓存系统和数据库的一些特性,因此有着丰富的应用场景.本文介绍Redis在Spring Boot中两个典型的应用场景. 如何使用 1.引入			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVQ9Vkp.html" rel="bookmark">Eclipse中java向数据库中添加数据，更新数据，删除数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面详细写过如何连接数据库的具体操作,下面介绍向数据库中添加数据. 注意事项:如果参考下面代码,需要 改包名,数据库名,数据库账号,密码,和数据表(数据表里面的信息) 1 package com.ningmeng; 2 3 import java.sql.*; 4 5 /** 6 * 1:向数据库中添加数据 7 * @author biexiansheng 8 * 9 */ 10 public class Test01 { 11 12 public static void main(String			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx0qVjM.html" rel="bookmark">head first c&num;-Head First C&num;第二版   在C&num;程序中添加一个&period;sdf项目</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Head First C#第二版 在C#程序中添加一个.sdf项目 ![图片说明](http://img.ask.csdn.net/upload/201508/03/1438578490_69763.jpg 本人C#新人 用&lt;Head First C#&gt;学习时 ,有一页让人在一个C#项目中新建一个.sdf项目 但是我找不到后缀名为.sdf的文件 求指点 本人安装了微软官方的vs2013 和SQL Server 2008 但是这两个怎样使用不是很了解 怎样连接不是很懂 希望懂得大神能详			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMydx5b.html" rel="bookmark" class="title">高性能HTTP加速器Varnish搭建、配置及优化</a>
					<div>
						 经过一天的努力,终于将Varnish缓存服务器部署到线上服务器了.趁着热乎劲儿,赶紧给大家分享一下.Varnish是一个轻量级的Cache和反向代理软件.先进的设计理念和成熟的设计框架是Varnis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYLDVb.html" rel="bookmark" class="title">phpexcel图形图表&lpar;一&rpar;入门</a>
					<div>
						PHPExcel - Excel的PHP处理引擎   PHPExcel 提供了一系列的 PHP语言 类,让你可以轻松地读写操作以下格式的文件:.xls/.xlsx/.csv/.ods/Gnumeric ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZVy6z.html" rel="bookmark" class="title">ASP中处理图像</a>
					<div>
						在ACESS中的确可以在字段中存储图象,但是...在ASP中却显示不出来,因为图象是二进制的数据,而且,在HTML页中,传到客户端的先是图象的地址,然后再到这个地址去将图片载下来,你难道还想让程序在某 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx70jb.html" rel="bookmark" class="title">3com&comma;bay交换机、路由器 密码恢复</a>
					<div>
						3COM用一种很奇怪的方式来维护他们售出的设备,那就是后门密码,任何的下列密码都是最高权限,可以自由设置设备. CoreBuilder 6000/2500 - username: debug pass ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrK8Jvp.html" rel="bookmark" class="title">Photoshop制作铜板蚀刻文字教程</a>
					<div>
						用Photoshop中描绘铜板蚀刻文字的详细步骤.步骤较为简单,但效果很棒.过程中会用到Photoshop的斜面和浮雕图层效果.图层叠加方式,并把很多不同的技巧结合起来,让文字与背景变得浑然一体. 完 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ75m7b.html" rel="bookmark" class="title">instagram被禁用怎么办？</a>
					<div>
						  1.如果你删除了你的账户,就无法还原,你可以使用之前的相同电子邮件地址创建新账户,但是不能得到相同的用户名. 2.如果您不遵守我们的社区指南或您所拥有的任何账户的使用条款,您的账户会在没有警告的情 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91wvVM.html" rel="bookmark" class="title">PHOTOSHOP调整色相饱和度和建立色相饱和度图层有什么区别啊？</a>
					<div>
						根本区别在于:前者是针对本图层调整,,调整后本图层发生改变并不可修复.并且,以后如果想继续调整,则只能针对上次调整结果作为起始点重新调整.而后者是新建图层对该图层进行调整,该图层本身并未发生改变,以后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKPO4M.html" rel="bookmark" class="title">巧用美图淘淘折扣素材清仓夏装</a>
					<div>
						秋冬换季之时,网店掌柜们大多都在忙两件事:夏装清仓甩卖和冬装新品上市.然而,众多的网店都在做同样的两件事,势必造成大量的商品雷同.那么,怎么做才能让自家的商品更容易被买家关注,实现销量的上升呢?用好美 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjm5OVz.html" rel="bookmark" class="title">整体配置均衡游戏本体验</a>
					<div>
						  尽管很多高端游戏本都争相使用夸张的造型.复合式材料来突出机身设计,却令人逐渐感到乏味.Cyber​​PowerPC在游戏PC领域中拥有不错的口碑,但其&quot;Fangbook&quot;游戏本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72Bnrp.html" rel="bookmark" class="title">怎么快速启动Mac屏幕保护程序</a>
					<div>
						  你可曾想过在mac下直接使用快捷键打开屏幕保护? 貌似你并不是一个人,这就是今天我要展示给大家的主题啦.作为默认,Mac OS X并不存在这样的功能,我们将示范使用 自动机 (Automator) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Zn0Pb.html" rel="bookmark" class="title">ruby技巧001&colon;求md5散列</a>
					<div>
						    ruby核心库中未包含md5之类的功能,不过在其标准库digest中可以方便的使用该功能: = Digest (from ruby core) ------------------------ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkrN2b.html" rel="bookmark" class="title">怎样制作一个简单ip，以方便在Quartus II和Nios II中使用？&period;&lbrack;Nios II&rsqb;&lbrack;下&rsqb;</a>
					<div>
						3 使用举例 注意:9.1环境. 3.1 在SOPC Builder中添加组件 从File-New Component..打开Component Editor,单击HDL Files标签,添加所编写的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkwd8yp.html" rel="bookmark" class="title">java-Java异常处理中居然有个try-finally？？？？</a>
					<div>
						问题描述 Java异常处理中居然有个try-finally???? 一般都是try-catch,或者try-catch-finally,突然发现还有try 后面直接跟finally?????,这种tr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgdjBb.html" rel="bookmark" class="title">ttribute rror-用elementtree解析xml文件总是报错 AttributeError&colon;</a>
					<div>
						问题描述 用elementtree解析xml文件总是报错 AttributeError: #-*- coding:utf-8 -*- from xml.etree import ElementTree ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rlXop.html" rel="bookmark" class="title">java和c&num;使用hessian通信</a>
					<div>
						介绍 hessian主页:http://hessian.caucho.com/ 一个简单的例子学习hessian服务:服务端为Java,客户端为C#. 先要准备好C#和Java的第三方类库:http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBjJ0M.html" rel="bookmark" class="title">PinyinUtil</a>
					<div>
						package com.css.common.util; import java.util.ArrayList; /**  * 拼音信息处理类  *  * @version 1.0  *  */ pu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5QxBM.html" rel="bookmark" class="title">《最终幻想14》未让玩家满意或将回炉重造</a>
					<div>
						&lt;最终幻想14&gt;自从9月发售以来就一直备受玩家和专业媒体批评的困扰,由于作品本身存在较为严重的问题因此Square Enix对于该作的后续改进与修复也是颇为用心.该作的制作人田中弘道表示他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqR0WRp.html" rel="bookmark" class="title">多媒体服务器架构实现方案（信息发布端 &plus; 服务器 &plus; 播放端） ？</a>
					<div>
						问题描述 多媒体服务器架构实现方案(信息发布端 + 服务器 + 播放端) ? 我想实现一个平台c/s架构,主要用多媒体信息资源的发布(类似于广告机的信息发布平台) 1. 信息发布控制端 (发布播放资源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl6dAp.html" rel="bookmark" class="title">PHP数字字符串左侧补0、字符串填充和自动补齐的几种方法&lowbar;php实例</a>
					<div>
						一.数字补0. 如果要自动生成学号,自动生成某某编号,就像这样的形式&quot;d0000009&quot;.&quot;d0000027&quot;时,那么就会面临一个问题,怎么把左边用0补齐成这样 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2R3mBb.html" rel="bookmark" class="title">img加载不出来-html下加载img的问题，图片资源访问变成下载</a>
					<div>
						问题描述 html下加载img的问题,图片资源访问变成下载 下面是html的代码,在本地直接用chrome打开,可以显示图片. 下面有几个问题: 1 如果把这个html页面放到tomcat下面,图片显 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba79Znp.html" rel="bookmark" class="title">后端开发-winphone手机后台搭建，求助大神们</a>
					<div>
						问题描述 winphone手机后台搭建,求助大神们 参加了微软的一个比赛,我们队打算做手机方面的.就是怎么搭建一个手机后台服务器,能给手机反馈消息(显示在手机上的).还能把手机三维空间信息画出来的.我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB17E9z.html" rel="bookmark" class="title">探真无阻塞加载javascript脚本技术，我们会发现很多意想不到的秘密</a>
					<div>
						原文:探真无阻塞加载javascript脚本技术,我们会发现很多意想不到的秘密 下面的图片是我使用firefox和chrome浏览百度首页时候记录的http请求   下面是firefox:   下面是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xJnKb.html" rel="bookmark" class="title">有道云笔记蒋炜航：对谷歌Keep的几点看法</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 Android版Google Keep截图 蒋炜航,有道云笔记负责人,网易技术总监 今天业内都在谈论Google推出云笔记产品Keep.对于Google ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7qYYz.html" rel="bookmark" class="title">关于datatable整个复制到ms sql的表中的问题。。。</a>
					<div>
						问题描述 我在程序中建立了一个datatabledt1..里边有一些数据...在数据库中有一个表demo...dt1和demo的结构都是一样的..我现在想把dt1复制到demo表中...我不想一条条的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlPPlp.html" rel="bookmark" class="title">浙江省放宽网络行业经营范围 云计算、物联网等列席</a>
					<div>
						昨日,记者从浙江省工商局获悉,为了使浙江网络市场继续领跑全国,浙江工商新出台了&lt;关于促进网络市场快速有序发展的若干意见&gt;(以下简称&lt;意见&gt;),今后电子商务企业在市场准入等方面将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NEKBb.html" rel="bookmark" class="title">JavaWeb基础教程之Java基础加强版&lowbar;java</a>
					<div>
						1.myeclipse的安装和使用 * eclipse:是一个免费的开发工具 * myeclipse:是一个收费的插件,破解myeclipse, ** 安装目录的要求: 不能有中文和空格 ** 安装完 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1lqqb.html" rel="bookmark" class="title">jquery中NProgress插件使用详解&lpar;中文&rpar;</a>
					<div>
						今天分享一下Jquery 简单大方美观的进度条插件-NProgress中文的使用和说明. 首先,官方地址: https://github.com/rstacruz/nprogress NProgres ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlVdAp.html" rel="bookmark" class="title">跟我学习javascript的prototype&comma;getPrototypeOf和&lowbar;&lowbar;proto&lowbar;&lowbar;&lowbar;javascript技巧</a>
					<div>
						一.深入理解prototype, getPrototypeOf和_ proto _ prototype,getPropertyOf和 _ proto _ 是三个用来访问prototype的方法.它们的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baq73gb.html" rel="bookmark" class="title">使用Cactus&plus;Jetty进行servelt的单元测试</a>
					<div>
						今天在做&lt;Junit In Action&gt;关于cactus和jetty结合进行集成测试的例子,看看源代码很简单,但总是运行不起来,一波三折了好几个小时才搞定.我用的cactus是1.8.1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdvvG6b.html" rel="bookmark" class="title">苹果回应艳照门：怪只怪明星密码太好猜</a>
					<div>
						好莱坞艳照门事件受害者之一影后劳伦斯9月3日消息,据国外媒体报道,苹果公司今日就好莱坞艳照门事件举办了一场新闻发布会,表示众位明星私密照的泄露并非来自于iCloud的系统漏洞,而是由于她们的密码太好猜 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.041 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
